//----------------------------------------------------------------------------
// CoolMenu.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: CoolMenu.pas
//----------------------------------------------------------------------------
#ifndef CoolMenuHPP
#define CoolMenuHPP
//----------------------------------------------------------------------------
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Forms.hpp>
#include <SysUtils.hpp>
#include <Graphics.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Coolmenu
{
//-- type declarations -------------------------------------------------------
enum TRefreshAction { RA_NONE, RA_REFRESH, RA_REFRESHWITHBAR, RA_RESTORE, RA_RESTOREWITHBAR };

typedef TAlign TTextAlign;

typedef TAlign TBarAlign;

enum TCaptionAlign { alUp, alDown, alCenter };

typedef void __fastcall (__closure *TMsgOccurs)(Messages::TMessage &Msg);

typedef void __fastcall (__closure *TRefreshEvent)(System::TObject* Sender, TRefreshAction Action);

typedef void __fastcall (__closure *TMenuEvent)(System::TObject* Sender, int MenuHandle, int Value);
	

enum TMenuOption { omAlwaysDefFont, omAlwaysDefFontColor, omAlwaysDefFontSize, omFixedImgSize, omDrawBarIfNeeded, 
	omPaintWallpaper, omPaintSelWallpaper, omTileWallpaper, omTileSelWallpaper, omBevelOnlyIfSel, omNoHighlightImage, 
	omNoHighlightDisabled, omNoHighlightEnabled, omNoHighlightEnabledButDoText, omNoHighlightEnabledButDoRoundRect, 
	omRightJustified, omNoImageAttached };

typedef Set<TMenuOption, omAlwaysDefFont, omNoImageAttached>  TMenuOptions;

typedef Shortint SpaceInt;

enum TBevelStyle { bsBevelBoth, bsBevelOnlyImage, bsBevelOnlyText };

enum TBevelType { btRectangle, btRoundedRect };

enum TShadowPosition { spLeftTop, spLeftBottom, spRightBottom, spRightTop };

enum TShadowOption { soNoShadowIfNormal, soNoShadowIfSel };

typedef Set<TShadowOption, soNoShadowIfNormal, soNoShadowIfSel>  TShadowOptions;

struct TGlobalParameters;
typedef TGlobalParameters *PGlobalParameters;

#pragma pack(push, 1)
struct TGlobalParameters
{
	Graphics::TFont* Font;
	Graphics::TColor Color;
	Graphics::TColor SelColor;
	Graphics::TColor TrColor;
	TMenuOptions Options;
	TAlign TextAlign;
	int ImgSize;
	TPanelBevel BevelInner;
	TPanelBevel BevelOuter;
	TBevelStyle BevelStyle;
	System::AnsiString SeparatorText;
} ;
#pragma pack(pop)

struct TGlobalShadow;
typedef TGlobalShadow *PGlobalShadow;

#pragma pack(push, 1)
struct TGlobalShadow
{
	bool Active;
	Graphics::TColor Color;
	Graphics::TColor SelColor;
	TShadowPosition Position;
	TShadowPosition SelPosition;
	Byte Size;
	Byte SelSize;
	TShadowOptions Options;
} ;
#pragma pack(pop)

struct TSizes;
typedef TSizes *PSizes;

#pragma pack(push, 1)
struct TSizes
{
	Windows::TRect ClientRect;
	int ImgLeft;
	int ImgTop;
	int TxtLeft;
	int TxtTop;
	int TxtWidth;
	int TxtHeight;
	int ImgTxtHeight;
	int mItemHeight;
	int mItemWidth;
	int AccWidth;
	int Margin;
} ;
#pragma pack(pop)

struct TCoolBarCaptionData;
typedef TCoolBarCaptionData *PCoolBarCaptionData;

#pragma pack(push, 1)
struct TCoolBarCaptionData
{
	System::AnsiString Caption;
	int Size;
	bool IsSerif;
	Graphics::TColor Fore;
} ;
#pragma pack(pop)

class __declspec(delphiclass) TShadowText;
class __declspec(pascalimplementation) TShadowText : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FActive;
	Graphics::TColor FShadowColor;
	Graphics::TColor FSelShadowColor;
	Byte FShadowSize;
	Byte FSelShadowSize;
	TShadowPosition FShadowPos;
	TShadowPosition FSelShadowPos;
	TShadowOptions FShadowOptions;
	
public:
	__fastcall virtual TShadowText(void);
	virtual void __fastcall Assign(Classes::TPersistent* p0);
	void __fastcall DrawShadowText(HDC p0, char * p1, const Windows::TRect &CoolMenu_, Word p3, bool p4
		);
	
__published:
	__property bool Active = {read=FActive, write=FActive, default=0};
	__property TShadowOptions Options = {read=FShadowOptions, write=FShadowOptions, default=2};
	__property Graphics::TColor ShadowColor = {read=FShadowColor, write=FShadowColor, default=-2147483628
		};
	__property Graphics::TColor SelShadowColor = {read=FSelShadowColor, write=FSelShadowColor, default=-2147483628
		};
	__property Byte ShadowSize = {read=FShadowSize, write=FShadowSize, default=1};
	__property Byte SelShadowSize = {read=FSelShadowSize, write=FSelShadowSize, default=1};
	__property TShadowPosition ShadowPos = {read=FShadowPos, write=FShadowPos, default=0};
	__property TShadowPosition SelShadowPos = {read=FSelShadowPos, write=FSelShadowPos, default=0};
public:
		
	/* TObject.Destroy */ __fastcall virtual ~TShadowText(void) { }
	
};

class __declspec(delphiclass) TCoolMenuBar;
class __declspec(pascalimplementation) TCoolMenuBar : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FActive;
	Classes::TList* List;
	System::AnsiString FCaption;
	int FSize;
	Word FSpace;
	Graphics::TColor FBackFrom;
	Graphics::TColor FBackTo;
	Graphics::TColor FFore;
	bool FIsSerif;
	bool FIsGradient;
	bool FIsSeparator;
	Classes::TNotifyEvent FOnChanged;
	TCaptionAlign FCaptionAlign;
	TAlign FBarAlign;
	virtual void __fastcall Changed(void);
	void __fastcall SetActive(bool p0);
	void __fastcall SetCaption( System::AnsiString p0);
	void __fastcall SetSize(int p0);
	void __fastcall SetSpace(Word p0);
	void __fastcall SetBackFrom(Graphics::TColor p0);
	void __fastcall SetBackTo(Graphics::TColor p0);
	void __fastcall SetFore(Graphics::TColor p0);
	void __fastcall SetIsSerif(bool p0);
	void __fastcall SetIsGradient(bool p0);
	void __fastcall SetIsSeparator(bool p0);
	void __fastcall SetCaptionAlign(TCaptionAlign p0);
	void __fastcall SetBarAlign(TBarAlign p0);
	
public:
	__fastcall virtual TCoolMenuBar(void);
	virtual void __fastcall Assign(Classes::TPersistent* p0);
	__fastcall virtual ~TCoolMenuBar(void);
	void __fastcall AddItem(const TCoolBarCaptionData &CoolMenu_);
	void __fastcall RemoveItem( System::AnsiString p0);
	void __fastcall DeleteItem(int p0);
	bool __fastcall GetItem(int p0, TCoolBarCaptionData &CoolMenu_);
	bool __fastcall SetItem(int p0, const TCoolBarCaptionData &CoolMenu_);
	void __fastcall Clear(void);
	
__published:
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property System::AnsiString Caption = {read=FCaption, write=SetCaption, nodefault};
	__property int Size = {read=FSize, write=SetSize, default=11};
	__property Word Space = {read=FSpace, write=SetSpace, default=0};
	__property Graphics::TColor BackFrom = {read=FBackFrom, write=SetBackFrom, default=0};
	__property Graphics::TColor BackTo = {read=FBackTo, write=SetBackTo, default=16711680};
	__property Graphics::TColor Fore = {read=FFore, write=SetFore, default=16777215};
	__property bool IsSerif = {read=FIsSerif, write=SetIsSerif, default=1};
	__property bool IsGradient = {read=FIsGradient, write=SetIsGradient, default=0};
	__property bool IsSeparator = {read=FIsSeparator, write=SetIsSeparator, default=1};
	__property TCaptionAlign CaptionAlign = {read=FCaptionAlign, write=SetCaptionAlign, default=1};
	__property TBarAlign BarAlign = {read=FBarAlign, write=SetBarAlign, default=3};
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
};

class __declspec(delphiclass) TMainMenuBar;
class __declspec(delphiclass) TCoolMenu;
class __declspec(delphiclass) TCoolMenuItem;
class __declspec(pascalimplementation) TCoolMenu : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	SpaceInt FHSpace;
	SpaceInt FVSpace;
	int FMaxWidth;
	int FMaxTxtWidth;
	int FMenuHeight;
	int FMaxAccWidth;
	bool FIsBar;
	bool FInMenu;
	bool FHandledMeasure;
	Classes::TList* FItems;
	Graphics::TBitmap* FWallPaper;
	Graphics::TBitmap* FSelWallPaper;
	Graphics::TBitmap* FBarBitmap;
	Graphics::TBitmap* FCheckedBitmap;
	Graphics::TBitmap* FRadioBitmap;
	bool FActive;
	TCoolMenuBar* FCoolMenuBar;
	void *FNewProc;
	void *FDefProc;
	TRefreshAction FRefresh;
	Controls::TCursor FCursor;
	TMainMenuBar* FMainMenuBar;
	Controls::TChangeLink* FImageChangeLink;
	Controls::TChangeLink* FDisabledImageChangeLink;
	Controls::TImageList* FImages;
	Controls::TImageList* FDisabledImages;
	TMenuEvent FOnMenuPopup;
	TMenuEvent FOnMenuMeasure;
	TMenuEvent FOnMenuItemSelect;
	void __fastcall CreateBarBitmap(Graphics::TBitmap* &p0,  System::AnsiString p1, int p2, bool p3, Word 
		p4, Graphics::TColor p5, Graphics::TColor p6, Graphics::TColor p7, bool p8, bool p9, TCaptionAlign 
		p10, TCoolMenuBar* p11);
	TCoolMenuItem* __fastcall GetItem(int p0);
	void __fastcall SetItem(int p0, TCoolMenuItem* p1);
	void __fastcall SetWallPaper(Graphics::TBitmap* p0);
	void __fastcall SetSelWallPaper(Graphics::TBitmap* p0);
	void __fastcall SetCheckedBitmap(Graphics::TBitmap* p0);
	void __fastcall SetRadioBitmap(Graphics::TBitmap* p0);
	void __fastcall SetActive(bool p0);
	void __fastcall SetCoolMenuBar(TCoolMenuBar* p0);
	void __fastcall SetMainMenuBar(TMainMenuBar* p0);
	void __fastcall SetImages(Controls::TImageList* p0);
	void __fastcall SetDisabledImages(Controls::TImageList* p0);
	void __fastcall ImageListChange(System::TObject* p0);
	void __fastcall DisabledImageListChange(System::TObject* p0);
	int __fastcall GetCount(void);
	int __fastcall MDIWndProc(Messages::TMessage &CoolMenu_);
	
protected:
	virtual void __fastcall GetChildren(Classes::TGetChildProc p0);
	virtual void __fastcall SetChildOrder(Classes::TComponent* p0, int p1);
	virtual void __fastcall Notification(Classes::TComponent* p0, Classes::TOperation p1);
	virtual void __fastcall Loaded(void);
	void __fastcall AddBar(void);
	void __fastcall RemoveBar(void);
	virtual void __fastcall WndProc(Messages::TMessage &CoolMenu_);
	
public:
	__property TCoolMenuItem* Items[int Index] = {read=GetItem, write=SetItem};
	__property int Count = {read=GetCount, nodefault};
	__property Graphics::TBitmap* BarBitmap = {read=FBarBitmap, nodefault};
	__fastcall virtual TCoolMenu(Classes::TComponent* p0);
	__fastcall virtual ~TCoolMenu(void);
	virtual void __fastcall Refresh(System::TObject* p0, TRefreshAction p1);
	void __fastcall AddImages(Controls::TImageList* p0, Controls::TImageList* p1, bool p2);
	virtual void __fastcall GlobalSetParameters(const TGlobalParameters &CoolMenu_, long p1);
	virtual void __fastcall GlobalSetShadow(const TGlobalShadow &CoolMenu_, long p1);
	void __fastcall RemoveItem(TCoolMenuItem* p0, bool p1);
	void __fastcall AddItem(TCoolMenuItem* p0);
	TCoolMenuItem* __fastcall NewItem(void);
	void __fastcall ExchangeItems(int p0, int p1);
	virtual void __fastcall RehookWnd(void);
	TCoolMenuItem* __fastcall FindItem(Menus::TMenu* p0, Menus::TMenuItem* p1);
	void __fastcall RefreshBar(System::TObject* p0);
	void __fastcall RefreshMainMenuBar(System::TObject* p0);
	
__published:
	__property TCoolMenuBar* CoolMenuBar = {read=FCoolMenuBar, write=SetCoolMenuBar, nodefault};
	__property Graphics::TBitmap* Wallpaper = {read=FWallPaper, write=SetWallPaper, nodefault};
	__property Graphics::TBitmap* SelWallpaper = {read=FSelWallPaper, write=SetSelWallPaper, nodefault}
		;
	__property bool Active = {read=FActive, write=SetActive, default=1};
	__property TRefreshAction MenuRefresh = {read=FRefresh, write=FRefresh, default=1};
	__property Controls::TCursor Cursor = {read=FCursor, write=FCursor, default=0};
	__property SpaceInt HSpace = {read=FHSpace, write=FHSpace, default=5};
	__property SpaceInt VSpace = {read=FVSpace, write=FVSpace, default=2};
	__property TMainMenuBar* MainMenuBar = {read=FMainMenuBar, write=SetMainMenuBar, nodefault};
	__property Controls::TImageList* Images = {read=FImages, write=SetImages, default=0};
	__property Controls::TImageList* DisabledImages = {read=FDisabledImages, write=SetDisabledImages, default=0
		};
	__property Graphics::TBitmap* CheckedBitmap = {read=FCheckedBitmap, write=SetCheckedBitmap, nodefault
		};
	__property Graphics::TBitmap* RadioBitmap = {read=FRadioBitmap, write=SetRadioBitmap, nodefault};
	__property TMenuEvent OnPopup = {read=FOnMenuPopup, write=FOnMenuPopup};
	__property TMenuEvent OnMeasure = {read=FOnMenuMeasure, write=FOnMenuMeasure};
	__property TMenuEvent OnItemSelect = {read=FOnMenuItemSelect, write=FOnMenuItemSelect};
};

class __declspec(pascalimplementation) TMainMenuBar : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FActive;
	bool FIsWallpaper;
	bool FIsBevels;
	Graphics::TColor FColor;
	Classes::TNotifyEvent FOnChanged;
	Controls::TWinControl* FForm;
	TCoolMenu* FCoolMenu;
	TPanelBevel FBevelInner;
	TPanelBevel FBevelOuter;
	void __fastcall SetActive(bool p0);
	void __fastcall SetIsWallpaper(bool p0);
	void __fastcall SetColor(Graphics::TColor p0);
	void __fastcall SetIsBevels(bool p0);
	void __fastcall SetBevelInner(Extctrls::TPanelBevel p0);
	void __fastcall SetBevelOuter(Extctrls::TPanelBevel p0);
	Windows::TRect __fastcall DrawMainMenuBar(HDC p0);
	void __fastcall WMNcPaint(Messages::TMessage &CoolMenu_);
	bool __fastcall CheckAssigned(void);
	
protected:
	virtual void __fastcall Changed(void);
	Windows::TRect __fastcall GetMainMenuBarRect(void);
	
public:
	__property Controls::TWinControl* Form = {read=FForm, write=FForm, nodefault};
	__property TCoolMenu* CMenu = {read=FCoolMenu, write=FCoolMenu, nodefault};
	__fastcall virtual TMainMenuBar(void);
	virtual void __fastcall Assign(Classes::TPersistent* p0);
	__fastcall virtual ~TMainMenuBar(void);
	
__published:
	__property bool Active = {read=FActive, write=SetActive, default=0};
	__property bool IsWallpaper = {read=FIsWallpaper, write=SetIsWallpaper, default=0};
	__property bool IsBevels = {read=FIsBevels, write=SetIsBevels, default=0};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=-2147483644};
	__property Extctrls::TPanelBevel BevelInner = {read=FBevelInner, write=SetBevelInner, default=0};
	__property Extctrls::TPanelBevel BevelOuter = {read=FBevelOuter, write=SetBevelOuter, default=0};
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
};

class __declspec(pascalimplementation) TCoolMenuItem : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	Graphics::TFont* FFont;
	Graphics::TPicture* FPicture;
	Graphics::TPicture* FDisabledPicture;
	Graphics::TColor FSelColor;
	Graphics::TColor FSelTextColor;
	Graphics::TColor FNormColor;
	Graphics::TColor FTrColor;
	Graphics::TColor FBarColor;
	TSizes *FSizes;
	TAlign FTextAlign;
	TMenuOptions FOptions;
	TCoolMenu* FParent;
	int FCustomImgSize;
	Menus::TMenu* FMenu;
	Menus::TMenuItem* FMenuItem;
	TPanelBevel FBevelInner;
	TPanelBevel FBevelOuter;
	TBevelStyle FBevelStyle;
	TBevelType FBevelType;
	System::AnsiString FSeparatorText;
	int FImageIndex;
	TShadowText* FShadow;
	void __fastcall SetMenuItem(Menus::TMenuItem* p0);
	void __fastcall SetFont(Graphics::TFont* p0);
	void __fastcall SetPicture(Graphics::TPicture* p0);
	void __fastcall SetDisabledPicture(Graphics::TPicture* p0);
	void __fastcall SetOptions(TMenuOptions p0);
	void __fastcall SetParent(TCoolMenu* p0);
	void __fastcall SetShadow(TShadowText* p0);
	void __fastcall SetImageIndex(int p0);
	
protected:
	virtual bool __fastcall IsAssigned(void);
	virtual bool __fastcall HasParent(void);
	virtual void __fastcall ReadState(Classes::TReader* p0);
	virtual Classes::TComponent* __fastcall GetParentComponent(void);
	virtual void __fastcall SetParentComponent(Classes::TComponent* p0);
	virtual void __fastcall Notification(Classes::TComponent* p0, Classes::TOperation p1);
	void __fastcall MeasureItem(Messages::TWMMeasureItem &CoolMenu_,  System::AnsiString p1,  System::AnsiString 
		p2);
	void __fastcall DrawItem(Messages::TWMDrawItem &CoolMenu_,  System::AnsiString p1,  System::AnsiString 
		p2);
	
public:
	__property TCoolMenu* Parent = {read=FParent, write=SetParent, nodefault};
	__fastcall virtual TCoolMenuItem(Classes::TComponent* p0);
	__fastcall virtual ~TCoolMenuItem(void);
	TCoolMenu* __fastcall Root(void);
	virtual void __fastcall Erase(void);
	
__published:
	__property Graphics::TFont* Font = {read=FFont, write=SetFont, nodefault};
	__property Graphics::TPicture* Picture = {read=FPicture, write=SetPicture, nodefault};
	__property Graphics::TPicture* DisabledPicture = {read=FDisabledPicture, write=SetDisabledPicture, 
		nodefault};
	__property Graphics::TColor TrColor = {read=FTrColor, write=FTrColor, default=536870911};
	__property Graphics::TColor SelColor = {read=FSelColor, write=FSelColor, default=-2147483635};
	__property Graphics::TColor NormColor = {read=FNormColor, write=FNormColor, default=-2147483644};
	__property TTextAlign TextAlign = {read=FTextAlign, write=FTextAlign, default=4};
	__property TMenuOptions Options = {read=FOptions, write=SetOptions, default=392};
	__property int CustomImgSize = {read=FCustomImgSize, write=FCustomImgSize, default=16};
	__property Menus::TMenu* Menu = {read=FMenu, write=FMenu, nodefault};
	__property Menus::TMenuItem* MenuItem = {read=FMenuItem, write=SetMenuItem, nodefault};
	__property Extctrls::TPanelBevel BevelInner = {read=FBevelInner, write=FBevelInner, default=0};
	__property Extctrls::TPanelBevel BevelOuter = {read=FBevelOuter, write=FBevelOuter, default=0};
	__property TBevelStyle BevelStyle = {read=FBevelStyle, write=FBevelStyle, default=0};
	__property TBevelType BevelType = {read=FBevelType, write=FBevelType, default=0};
	__property System::AnsiString SeparatorText = {read=FSeparatorText, write=FSeparatorText, nodefault
		};
	__property int ImageIndex = {read=FImageIndex, write=SetImageIndex, default=-1};
	__property Graphics::TColor SelTextColor = {read=FSelTextColor, write=FSelTextColor, default=-2147483634
		};
	__property TShadowText* Shadow = {read=FShadow, write=SetShadow, nodefault};
};

//-- var, const, procedure ---------------------------------------------------
#define crCool (Byte)(5)
#define GSP_ALL (Byte)(0)
#define GSP_FONT (Byte)(1)
#define GSP_COLOR (Byte)(2)
#define GSP_SELCOLOR (Byte)(4)
#define GSP_TRCOLOR (Byte)(8)
#define GSP_TEXTALIGN (Byte)(32)
#define GSP_IMGSIZE (Byte)(64)
#define GSP_EQ_OPTIONS (Byte)(128)
#define GSP_ADD_OPTIONS (Word)(256)
#define GSP_DEL_OPTIONS (Word)(512)
#define GSP_BEVELINNER (Word)(1024)
#define GSP_BEVELOUTER (Word)(2048)
#define GSP_BEVELSTYLE (Word)(4096)
#define GSP_SEPARATORTEXT (Word)(8192)
#define GSS_ALL (Byte)(0)
#define GSS_ACTIVE (Byte)(1)
#define GSS_COLOR (Byte)(2)
#define GSS_SELCOLOR (Byte)(4)
#define GSS_POSITION (Byte)(8)
#define GSS_SELPOSITION (Byte)(16)
#define GSS_SIZE (Byte)(32)
#define GSS_SELSIZE (Byte)(64)
#define GSS_EQ_OPTIONS (Byte)(128)
#define GSS_ADD_OPTIONS (Word)(256)
#define GSS_DEL_OPTIONS (Word)(512)
//-- template instantiations -------------------------------------------------
template class TShadowOptions ;
template class TMenuOptions ;

}	/* namespace Coolmenu */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Coolmenu;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// CoolMenu
